# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class StructuredOrderListRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {'_from': 'int', 'to': 'int', 'page': 'int', 'limit': 'int'}

    attribute_map = {'_from': 'from', 'to': 'to', 'page': 'page', 'limit': 'limit'}

    def __init__(self, _from=None, to=None, page=None, limit=None, local_vars_configuration=None):  # noqa: E501
        # type: (int, int, int, int, Configuration) -> None
        """StructuredOrderListRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self.__from = None
        self._to = None
        self._page = None
        self._limit = None
        self.discriminator = None

        self._from = _from
        self.to = to
        if page is not None:
            self.page = page
        if limit is not None:
            self.limit = limit

    @property
    def _from(self):
        """Gets the _from of this StructuredOrderListRequest.  # noqa: E501

        start time  # noqa: E501

        :return: The _from of this StructuredOrderListRequest.  # noqa: E501
        :rtype: int
        """
        return self.__from

    @_from.setter
    def _from(self, _from):
        """Sets the _from of this StructuredOrderListRequest.

        start time  # noqa: E501

        :param _from: The _from of this StructuredOrderListRequest.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and _from is None:  # noqa: E501
            raise ValueError("Invalid value for `_from`, must not be `None`")  # noqa: E501

        self.__from = _from

    @property
    def to(self):
        """Gets the to of this StructuredOrderListRequest.  # noqa: E501

        Finished time  # noqa: E501

        :return: The to of this StructuredOrderListRequest.  # noqa: E501
        :rtype: int
        """
        return self._to

    @to.setter
    def to(self, to):
        """Sets the to of this StructuredOrderListRequest.

        Finished time  # noqa: E501

        :param to: The to of this StructuredOrderListRequest.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and to is None:  # noqa: E501
            raise ValueError("Invalid value for `to`, must not be `None`")  # noqa: E501

        self._to = to

    @property
    def page(self):
        """Gets the page of this StructuredOrderListRequest.  # noqa: E501

        Page number  # noqa: E501

        :return: The page of this StructuredOrderListRequest.  # noqa: E501
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page):
        """Sets the page of this StructuredOrderListRequest.

        Page number  # noqa: E501

        :param page: The page of this StructuredOrderListRequest.  # noqa: E501
        :type: int
        """

        self._page = page

    @property
    def limit(self):
        """Gets the limit of this StructuredOrderListRequest.  # noqa: E501

        Number of items returned in the list. Default is 100.  # noqa: E501

        :return: The limit of this StructuredOrderListRequest.  # noqa: E501
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this StructuredOrderListRequest.

        Number of items returned in the list. Default is 100.  # noqa: E501

        :param limit: The limit of this StructuredOrderListRequest.  # noqa: E501
        :type: int
        """

        self._limit = limit

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StructuredOrderListRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StructuredOrderListRequest):
            return True

        return self.to_dict() != other.to_dict()
